#ifndef _ECMEASURE_H_
#define _ECMEASURE_H_
/*
  Sample program of ec measurement w/o thermal calibration from jitaku-yasai.com
*/
#include "mcp3004.hpp"
#include "type.h"

#define NUMSHOTS 10

class EcMeasure : public MCP3004 {

public:
  void  SetRefResistance(float refResistance);       // Registance which devides voltage
  float GetRefResistance();
  float GetEC(int numshots = NUMSHOTS);              // GetEc
  ~EcMeasure();                                      // Destructor

private:
  float ec;
  float resistance;
  float refResistance;
  float FindPeak(int ch = MCP3004_CHANNEL0, int numshots = NUMSHOTS);
};

inline
void
EcMeasure::SetRefResistance(float theRefResistance)
{
  refResistance = theRefResistance;
}

inline
float
EcMeasure::GetRefResistance()
{
  return refResistance;
}


#endif
