#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "ecMeasure.hpp"
#include "thermistor.hpp"

int
main(int argc, char *argv[])
{
  // current time
  time_t now = time(NULL);
  struct tm *pnow = localtime(&now);
  char strDateNow[16];
  char strTimeNow[16];
  sprintf(strDateNow, "%04d-%02d-%02d", pnow->tm_year+1900, pnow->tm_mon+1, pnow->tm_mday);
  sprintf(strTimeNow, "%02d:%02d:%02d", pnow->tm_hour, pnow->tm_min, pnow->tm_sec);

  // initialization of classes and operation
  EcMeasure ec = EcMeasure();
  Thermistor thermistor = Thermistor();

  // initial setup before SPI communication start
  ec.SPISetUp();
  ec.SetRefResistance(1000.0);

  // skip SPI setup because it has already done by EcMeasure class.
  thermistor.SetRefResistance(10000.0);

  printf("Resistance and temperature : %s %s %4.2f %4.2f\n",
   strDateNow, strTimeNow, ec.GetEC(), thermistor.GetTemperature());

  return 0;
}
