/*
  Sample program of MCP3004 from jitaku-yasai.com
  MCP3004 specification :
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <wiringPi.h>
#include <wiringPiSPI.h>
#include "mcp3004.hpp"

MCP3004::MCP3004(uint theChannelOfRP, uint theSpiSpeed)
{
  // Parameters
  channelOfRP   = theChannelOfRP;
  spiSpeed      = theSpiSpeed;
}

int
MCP3004::SPISetUp()
{
  return wiringPiSPISetup(channelOfRP, spiSpeed);
}

int
MCP3004::WriteRead(uint adcCH)
{
  // initialize buffer
  memset(data, 0, DATALEN);

  // set buffer for inquiry
  data[0] = MCP3004_START_BIT;
  data[1] = MCP3004_SGL_BIT | MCP3004_DONTCARE;

  // Channel setting
  if (MCP3004_CHANNEL0 == adcCH) data[1] |=  MCP3004_CH0_BIT;
  if (MCP3004_CHANNEL1 == adcCH) data[1] |=  MCP3004_CH1_BIT;
  if (MCP3004_CHANNEL2 == adcCH) data[1] |=  MCP3004_CH2_BIT;
  if (MCP3004_CHANNEL3 == adcCH) data[1] |=  MCP3004_CH3_BIT;


  wiringPiSPIDataRW(channelOfRP, data, DATALEN);  // Write and receive from same buffer
  return (int)((data[1] << 8 | data[2]) & 0x3FF);
}

MCP3004::~MCP3004()
{
}
